#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 15 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"



#line 12 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
static const signed char _is_numeric_string_key_offsets[] = {
	0, 0, 3, 0
};

static const char _is_numeric_string_trans_keys[] = {
	32, 48, 57, 32, 48, 57, 0
};

static const signed char _is_numeric_string_single_lengths[] = {
	0, 1, 1, 0
};

static const signed char _is_numeric_string_range_lengths[] = {
	0, 1, 1, 0
};

static const signed char _is_numeric_string_index_offsets[] = {
	0, 0, 3, 0
};

static const signed char _is_numeric_string_cond_targs[] = {
	2, 2, 0, 2, 2, 0, 0, 1,
	2, 0
};

static const int is_numeric_string_start = 1;
static const int is_numeric_string_first_final = 2;
static const int is_numeric_string_error = 0;

static const int is_numeric_string_en_main = 1;


#line 17 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"


bool is_numeric_string(const char *const in, const size_t len)
{
	const char *p = in;
	const char *const pe = in + len;
	int cs;
	
	
#line 55 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
	{
		cs = (int)is_numeric_string_start;
	}
	
#line 60 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.c"
	{
		int _klen;
		unsigned int _trans = 0;
		const char * _keys;
		_resume: {}
		if ( p == pe )
			goto _out;
		_keys = ( _is_numeric_string_trans_keys + (_is_numeric_string_key_offsets[cs]));
		_trans = (unsigned int)_is_numeric_string_index_offsets[cs];
		
		_klen = (int)_is_numeric_string_single_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + _klen - 1;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_keys += _klen;
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + ((_upper-_lower) >> 1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 1;
				else if ( ( (*( p))) > (*( _mid)) )
					_lower = _mid + 1;
				else {
					_trans += (unsigned int)(_mid - _keys);
					goto _match;
				}
			}
		}
		
		_klen = (int)_is_numeric_string_range_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + (_klen<<1) - 2;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + (((_upper-_lower) >> 1) & ~1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 2;
				else if ( ( (*( p))) > (*( _mid + 1)) )
					_lower = _mid + 2;
				else {
					_trans += (unsigned int)((_mid - _keys)>>1);
					break;
				}
			}
		}
		
		_match: {}
		cs = (int)_is_numeric_string_cond_targs[_trans];
		
		
		if ( cs != 0 ) {
			p += 1;
			goto _resume;
		}
		_out: {}
	}
	
#line 28 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/numeric_string.rl"
	
	
	return cs != is_numeric_string_error;
}
