#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 23 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.rl"



#line 12 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.c"
static const signed char _is_oid_key_offsets[] = {
	0, 0, 7, 8, 11, 14, 15, 18,
	0
};

static const char _is_oid_trans_keys[] = {
	48, 49, 57, 65, 90, 97, 122, 46,
	48, 49, 57, 46, 48, 57, 46, 46,
	48, 57, 45, 48, 57, 65, 90, 97,
	122, 0
};

static const signed char _is_oid_single_lengths[] = {
	0, 1, 1, 1, 1, 1, 1, 1,
	0
};

static const signed char _is_oid_range_lengths[] = {
	0, 3, 0, 1, 1, 0, 1, 3,
	0
};

static const signed char _is_oid_index_offsets[] = {
	0, 0, 5, 7, 10, 13, 15, 18,
	0
};

static const signed char _is_oid_cond_targs[] = {
	2, 4, 7, 7, 0, 3, 0, 5,
	6, 0, 3, 4, 0, 3, 0, 3,
	6, 0, 7, 7, 7, 7, 0, 0,
	1, 2, 3, 4, 5, 6, 7, 0
};

static const int is_oid_start = 1;
static const int is_oid_first_final = 5;
static const int is_oid_error = 0;

static const int is_oid_en_main = 1;


#line 25 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.rl"


bool is_oid(const char *const in, const size_t len)
{
	const char *p = in;
	const char *const pe = in + len;
	int cs;
	
	
#line 64 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.c"
	{
		cs = (int)is_oid_start;
	}
	
#line 69 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.c"
	{
		int _klen;
		unsigned int _trans = 0;
		const char * _keys;
		_resume: {}
		if ( p == pe )
			goto _out;
		_keys = ( _is_oid_trans_keys + (_is_oid_key_offsets[cs]));
		_trans = (unsigned int)_is_oid_index_offsets[cs];
		
		_klen = (int)_is_oid_single_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + _klen - 1;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_keys += _klen;
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + ((_upper-_lower) >> 1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 1;
				else if ( ( (*( p))) > (*( _mid)) )
					_lower = _mid + 1;
				else {
					_trans += (unsigned int)(_mid - _keys);
					goto _match;
				}
			}
		}
		
		_klen = (int)_is_oid_range_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + (_klen<<1) - 2;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + (((_upper-_lower) >> 1) & ~1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 2;
				else if ( ( (*( p))) > (*( _mid + 1)) )
					_lower = _mid + 2;
				else {
					_trans += (unsigned int)((_mid - _keys)>>1);
					break;
				}
			}
		}
		
		_match: {}
		cs = (int)_is_oid_cond_targs[_trans];
		
		
		if ( cs != 0 ) {
			p += 1;
			goto _resume;
		}
		_out: {}
	}
	
#line 36 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/oid.rl"
	
	
	return cs != is_oid_error;
}
