#line 1 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.rl"
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>


#line 25 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.rl"



#line 12 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.c"
static const signed char _is_utc_time_key_offsets[] = {
	0, 0, 2, 4, 6, 8, 12, 14,
	17, 19, 21, 23, 26, 28, 30, 32,
	34, 36, 38, 40, 42, 44, 49, 49,
	0
};

static const char _is_utc_time_trans_keys[] = {
	48, 57, 48, 57, 48, 49, 49, 57,
	48, 51, 49, 50, 49, 57, 50, 48,
	49, 48, 57, 48, 53, 48, 57, 50,
	48, 49, 48, 57, 48, 53, 48, 57,
	48, 51, 48, 57, 48, 51, 48, 57,
	48, 49, 48, 50, 43, 45, 90, 48,
	53, 43, 45, 90, 0
};

static const signed char _is_utc_time_single_lengths[] = {
	0, 0, 0, 2, 0, 2, 0, 1,
	0, 0, 0, 1, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 3, 0, 3,
	0
};

static const signed char _is_utc_time_range_lengths[] = {
	0, 1, 1, 0, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 0, 0,
	0
};

static const signed char _is_utc_time_index_offsets[] = {
	0, 0, 2, 4, 7, 9, 13, 15,
	18, 20, 22, 24, 27, 29, 31, 33,
	35, 37, 39, 41, 43, 45, 50, 51,
	0
};

static const signed char _is_utc_time_cond_targs[] = {
	2, 0, 3, 0, 4, 20, 0, 5,
	0, 6, 19, 18, 0, 7, 0, 17,
	8, 0, 9, 0, 10, 0, 21, 0,
	15, 12, 0, 13, 0, 14, 0, 22,
	0, 13, 0, 23, 0, 9, 0, 7,
	0, 7, 0, 5, 0, 11, 11, 22,
	16, 0, 0, 11, 11, 22, 0, 0,
	1, 2, 3, 4, 5, 6, 7, 8,
	9, 10, 11, 12, 13, 14, 15, 16,
	17, 18, 19, 20, 21, 22, 23, 0
};

static const int is_utc_time_start = 1;
static const int is_utc_time_first_final = 21;
static const int is_utc_time_error = 0;

static const int is_utc_time_en_main = 1;


#line 27 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.rl"


bool is_utc_time(const char *const in, const size_t len)
{
	const char *p = in;
	const char *const pe = in + len;
	int cs;
	
	
#line 81 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.c"
	{
		cs = (int)is_utc_time_start;
	}
	
#line 86 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.c"
	{
		int _klen;
		unsigned int _trans = 0;
		const char * _keys;
		_resume: {}
		if ( p == pe )
			goto _out;
		_keys = ( _is_utc_time_trans_keys + (_is_utc_time_key_offsets[cs]));
		_trans = (unsigned int)_is_utc_time_index_offsets[cs];
		
		_klen = (int)_is_utc_time_single_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + _klen - 1;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_keys += _klen;
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + ((_upper-_lower) >> 1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 1;
				else if ( ( (*( p))) > (*( _mid)) )
					_lower = _mid + 1;
				else {
					_trans += (unsigned int)(_mid - _keys);
					goto _match;
				}
			}
		}
		
		_klen = (int)_is_utc_time_range_lengths[cs];
		if ( _klen > 0 ) {
			const char *_lower = _keys;
			const char *_upper = _keys + (_klen<<1) - 2;
			const char *_mid;
			while ( 1 ) {
				if ( _upper < _lower ) {
					_trans += (unsigned int)_klen;
					break;
				}
				
				_mid = _lower + (((_upper-_lower) >> 1) & ~1);
				if ( ( (*( p))) < (*( _mid)) )
					_upper = _mid - 2;
				else if ( ( (*( p))) > (*( _mid + 1)) )
					_lower = _mid + 2;
				else {
					_trans += (unsigned int)((_mid - _keys)>>1);
					break;
				}
			}
		}
		
		_match: {}
		cs = (int)_is_utc_time_cond_targs[_trans];
		
		
		if ( cs != 0 ) {
			p += 1;
			goto _resume;
		}
		_out: {}
	}
	
#line 38 "/usr/src/RPM/BUILD/libdomain-0.9.13/src/syntaxes/utc_time.rl"
	
	
	return cs != is_utc_time_error;
}
